## ompl 0.13.0+git20130920.01d0ca4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(ompl CXX C)

# set the default build type
if (NOT CMAKE_BUILD_TYPE)
    # By default, use Release mode
    set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Type of build" FORCE)

    # On 32bit architectures with gcc < 4.7, use RelWithDebInfo
    if (CMAKE_COMPILER_IS_GNUCC AND CMAKE_SIZEOF_VOID_P EQUAL 4)
        execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion OUTPUT_VARIABLE GCC_VERSION)
        if (GCC_VERSION VERSION_LESS 4.7)
            set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Type of build" FORCE)
        endif()
    endif()
endif()

message(STATUS "Building ${CMAKE_BUILD_TYPE}")

# This shouldn't be necessary, but there has been trouble
# with MSVC being set off, but MSVCXX ON.
if(MSVC OR MSVC90 OR MSVC10)
    set(MSVC ON)
endif (MSVC OR MSVC90 OR MSVC10)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules")
include(CompilerSettings)
include(OMPLVersion)
include(OMPLUtils)

set(EXECUTABLE_OUTPUT_PATH "${PROJECT_BINARY_DIR}/bin")
set(LIBRARY_OUTPUT_PATH "${PROJECT_BINARY_DIR}/lib")

set(OMPL_CMAKE_UTIL_DIR "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules"
    CACHE FILEPATH "Path to directory with auxiliary CMake scripts for OMPL")
set(OMPL_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/src")
set(OMPL_DEMO_INSTALL_DIR "share/ompl${OMPL_INSTALL_SUFFIX}/demos"
    CACHE STRING "Relative path to directory where demos will be installed")
set(OMPL_DOC_INSTALL_DIR "share/ompl${OMPL_INSTALL_SUFFIX}/doc"
    CACHE STRING "Relative path to directory where documentation will be installed")

include_directories("${OMPL_INCLUDE_DIR}")


if(MSVC)
    add_definitions(-DBOOST_ALL_NO_LIB)
    add_definitions(-DBOOST_PROGRAM_OPTIONS_DYN_LINK)
endif(MSVC)
if(IS_ICPC)
    set(Boost_USE_STATIC_LIBS ON CACHE STRING "Use statically linked Boost libraries")
else(IS_ICPC)
    # Ensure dynamic linking with boost unit_test_framework
    add_definitions(-DBOOST_TEST_DYN_LINK)
endif(IS_ICPC)

# Do one quiet find_package on Boost to see if it is recent enough to
# have the try_join_for call
find_package(Boost QUIET 1.50)

# try_join_for requires the chrono library, so if we will use
# try_join_for, we need to include the chrono component
# Must recheck the Boost version, since update_bindings will re-run CMake
# and this will pass for versions of Boost < 1.50
if (${Boost_FOUND} AND ${Boost_VERSION} GREATER 104900) # Boost version is at least 1.50
  # we're using chrono
  find_package(Boost COMPONENTS date_time thread serialization filesystem system program_options unit_test_framework chrono REQUIRED)
else()
  # don't use chrono
  find_package(Boost COMPONENTS date_time thread serialization filesystem system program_options unit_test_framework REQUIRED)
endif()
include_directories(SYSTEM ${Boost_INCLUDE_DIR})

if (NOT ${Boost_VERSION} LESS 104400)
  option(OMPL_ODESOLVER "Enable OMPL ODE solver classes" ON)
  if(${Boost_VERSION} LESS 105300)
    # Include bundled version of boost::odeint if it isn't installed natively
    set(ODEINT_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/src/external")
    include_directories(SYSTEM "${ODEINT_INCLUDE_DIR}")
  endif()
else()
  option(OMPL_ODESOLVER "Enable OMPL ODE solver classes" OFF)
endif()

# pthread is sometimes needed, depending on OS / compiler
find_package(Threads QUIET)

enable_testing()

# ODE is only needed for Open Dynamics Engine bindings
find_package(OpenDE QUIET)
set(OMPL_EXTENSION_OPENDE ${OPENDE_FOUND})
if (OPENDE_FOUND)
  add_definitions(${OPENDE_DEFINITIONS})
  include_directories(SYSTEM ${OPENDE_INCLUDE_DIR})
endif()

find_package(Triangle QUIET)
set(OMPL_EXTENSION_TRIANGLE ${TRIANGLE_FOUND})
if (TRIANGLE_FOUND)
  include_directories(SYSTEM ${TRIANGLE_INCLUDE_DIR})
endif()

# If FLANN is installed, a wrapper for its nearest neighbor data structures can be used
find_package(flann 1.8.3 QUIET)
if (FLANN_FOUND)
    set(OMPL_HAVE_FLANN 1)
    include_directories(SYSTEM "${FLANN_INCLUDE_DIRS}")
endif()

add_subdirectory(py-bindings)
add_subdirectory(src)
add_subdirectory(tests)
add_subdirectory(demos)
add_subdirectory(scripts)
add_subdirectory(doc)

if (NOT MSVC)
  set(PKG_NAME "ompl")
  set(PKG_DESC "The Open Motion Planning Library")
  set(PKG_OMPL_LIBS "-lompl")
  set(pkg_conf_file "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/ompl.pc")
  configure_file("${pkg_conf_file}.in" "${pkg_conf_file}" @ONLY)
  install(FILES "${pkg_conf_file}" DESTINATION lib/pkgconfig/
    COMPONENT pkgconfig RENAME "ompl${OMPL_INSTALL_SUFFIX}.pc")

  install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/doc/markdown/FindOMPL.cmake"
    DESTINATION "share/ompl${OMPL_INSTALL_SUFFIX}"
    RENAME ompl-config.cmake)
  if (NOT ${CMAKE_VERSION} VERSION_LESS 2.8.6)
    include(WriteBasicConfigVersionFile)
    write_basic_config_version_file(
      "${CMAKE_CURRENT_BINARY_DIR}/ompl-config-version.cmake"
      VERSION ${OMPL_VERSION} COMPATIBILITY SameMajorVersion)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/ompl-config-version.cmake"
      DESTINATION "share/ompl${OMPL_INSTALL_SUFFIX}")
  endif()
endif()

# uninstall target
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)
add_custom_target(uninstall
  COMMAND ${CMAKE_COMMAND} -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

if (OMPL_VERSIONED_INSTALL)
  # script to create sym links
  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/create_symlinks.sh.in"
    "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/create_symlinks.sh" @ONLY)
  execute_process(COMMAND
    "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/create_symlinks.sh"
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")
  install(DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/.symlinks/" DESTINATION .)
  # script to uninstall sym links
  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/uninstall_symlinks.sh.in"
    "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/uninstall_symlinks.sh" @ONLY)
  add_custom_target(uninstall_links COMMAND
    "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/uninstall_symlinks.sh")
  add_dependencies(uninstall uninstall_links)
endif()
include(CPackSettings)

option(OMPL_REGISTRATION "Enable one-time registration of OMPL" ON)
if (OMPL_REGISTRATION)
    find_file(OMPL_REGISTERED ".registered" PATHS "${CMAKE_CURRENT_SOURCE_DIR}" NO_DEFAULT_PATH)
    if (NOT OMPL_REGISTERED)
        file(WRITE "${CMAKE_CURRENT_SOURCE_DIR}/.registered" "")
        find_package(Python QUIET)
        if (PYTHON_FOUND)
            execute_process(COMMAND "${PYTHON_EXEC}" "-m" "webbrowser" "http://ompl.kavrakilab.org/core/register.html"
                OUTPUT_QUIET ERROR_QUIET)
        endif()
    endif()
endif()

=== demos/CMakeLists.txt ===
option(OMPL_BUILD_DEMOS "Build OMPL demos" ON)

if (OMPL_BUILD_DEMOS)

  macro(add_ompl_demo demo_name)
    add_executable(${ARGV})
    target_link_libraries(${demo_name}
      ompl
      ${Boost_FILESYSTEM_LIBRARY}
      ${Boost_SYSTEM_LIBRARY}
      ${Boost_THREAD_LIBRARY}
      ${Boost_DATE_TIME_LIBRARY}
      ${Boost_PROGRAM_OPTIONS_LIBRARY})
  endmacro(add_ompl_demo)

  add_ompl_demo(demo_RigidBodyPlanning RigidBodyPlanning.cpp)
  add_ompl_demo(demo_RigidBodyPlanningWithIK RigidBodyPlanningWithIK.cpp)
  add_ompl_demo(demo_RigidBodyPlanningWithControls RigidBodyPlanningWithControls.cpp)
  add_ompl_demo(demo_RigidBodyPlanningWithIntegrationAndControls RigidBodyPlanningWithIntegrationAndControls.cpp)
  if (OMPL_ODESOLVER)
      add_ompl_demo(demo_RigidBodyPlanningWithODESolverAndControls RigidBodyPlanningWithODESolverAndControls.cpp)
  endif()

  add_ompl_demo(demo_StateSampling StateSampling.cpp)
  add_ompl_demo(demo_GeometricCarPlanning GeometricCarPlanning.cpp)
  add_ompl_demo(demo_HybridSystemPlanning HybridSystemPlanning.cpp)
  aux_source_directory(Koules Koules_SRC)
  add_ompl_demo(demo_Koules ${Koules_SRC})

  add_ompl_demo(demo_OptimalPlanning OptimalPlanning.cpp)

  if (OMPL_EXTENSION_OPENDE)
    add_ompl_demo(demo_OpenDERigidBodyPlanning OpenDERigidBodyPlanning.cpp)
  endif()

  if (OMPL_EXTENSION_TRIANGLE)
    add_ompl_demo(demo_TriangulationDemo TriangulationDemo.cpp)
  endif()

# Only build the PlannerData demo on Boost >= 1.44
  if(NOT "${Boost_VERSION}" LESS 104400)
    add_ompl_demo(demo_PlannerData PlannerData.cpp)
  endif(NOT "${Boost_VERSION}" LESS 104400)
endif(OMPL_BUILD_DEMOS)

file(GLOB OMPL_DEMO_CXX_FILES "*.cpp")
file(GLOB OMPL_DEMO_PY_FILES "*.py")
install(FILES ${OMPL_DEMO_CXX_FILES} ${OMPL_DEMO_PY_FILES} DESTINATION "${OMPL_DEMO_INSTALL_DIR}")
install(DIRECTORY Koules DESTINATION "${OMPL_DEMO_INSTALL_DIR}")

=== doc/CMakeLists.txt ===
option(OMPL_BUILD_DOC "Build OMPL documentation" ON)

if (OMPL_BUILD_DOC)

    find_package(Doxygen QUIET)

    if(DOXYGEN)
        if(UNIX)
            execute_process(COMMAND date "+%b %d, %Y"
                OUTPUT_VARIABLE OMPL_RELEASE_DATE
                OUTPUT_STRIP_TRAILING_WHITESPACE)
        endif()
        configure_file("${CMAKE_CURRENT_SOURCE_DIR}/markdown/download.md.in"
            "${CMAKE_CURRENT_SOURCE_DIR}/markdown/download.md")
        configure_file("${CMAKE_CURRENT_SOURCE_DIR}/markdown/mainpage.md.in"
            "${CMAKE_CURRENT_SOURCE_DIR}/markdown/mainpage.md")
        file(READ "${CMAKE_CURRENT_SOURCE_DIR}/images/ompl.svg" OMPLSVG)
        configure_file("${CMAKE_CURRENT_SOURCE_DIR}/markdown/api_overview.md.in"
            "${CMAKE_CURRENT_SOURCE_DIR}/markdown/api_overview.md")

        # add "doc" target if Doxygen is detected
        add_custom_target(doc
            COMMAND ./mkdocs.sh
            WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")

        # add "website" target
        add_custom_target(website
            COMMAND ./mkwebdocs.sh
            DEPENDS doc
            WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")
    endif(DOXYGEN)

endif(OMPL_BUILD_DOC)

=== py-bindings/CMakeLists.txt ===
option(OMPL_BUILD_PYBINDINGS "Build OMPL Python bindings" ON)
option(OMPL_BUILD_PYTESTS "Build OMPL Python tests" ON)

if (OMPL_BUILD_PYBINDINGS)

    include(PythonBindingsUtils)

    if(WIN32)
        # omit StateStorage class bindings on Windows;
        # Boost.Serialization does nasty things that break the bindings.
        set(PYOMPL_EXTRA_CFLAGS "${PYOMPL_EXTRA_CFLAGS} -DOMPL_BASE_STATE_STORAGE_ -DOMPL_BASE_PLANNER_DATA_STORAGE_ -DOMPL_CONTROL_PLANNER_DATA_STORAGE_")
        add_definitions(-DOMPL_BASE_STATE_STORAGE_ -DOMPL_BASE_PLANNER_DATA_STORAGE_ -DOMPL_CONTROL_PLANNER_DATA_STORAGE_)
    endif(WIN32)

    set(OMPL_MODULES base control geometric tools util)

    if(PY_OMPL_GENERATE)
        # need to run cmake to regenerate ompl/bindings_generator.py if
        # bindings_generator.py.in is changed.
        configure_file("${CMAKE_CURRENT_SOURCE_DIR}/bindings_generator.py.in"
            "${CMAKE_CURRENT_SOURCE_DIR}/ompl/bindings_generator.py" @ONLY)

        foreach(module ${OMPL_MODULES})
            create_module_generation_targets(${module} "${CMAKE_CURRENT_SOURCE_DIR}")
        endforeach(module)

        add_dependencies(update_base_bindings update_util_bindings)
        add_dependencies(update_geometric_bindings update_base_bindings)
        add_dependencies(update_control_bindings update_geometric_bindings)
        add_dependencies(update_control_bindings update_base_bindings)
        add_dependencies(update_tools_bindings update_control_bindings)

    endif(PY_OMPL_GENERATE)

    if(PY_OMPL_COMPILE AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/bindings")
        foreach(module ${OMPL_MODULES})
            create_module_target(${module} "${CMAKE_CURRENT_SOURCE_DIR}")
        endforeach(module)

        install(DIRECTORY ompl DESTINATION "${OMPL_PYTHON_INSTALL_DIR}"
            PATTERN .svn EXCLUDE PATTERN "*.pyc" EXCLUDE PATTERN "_*.so" EXCLUDE)
    endif()

endif(OMPL_BUILD_PYBINDINGS)

add_custom_target(clean_bindings
    "${CMAKE_COMMAND}" -E remove_directory "${CMAKE_CURRENT_SOURCE_DIR}/bindings"
    COMMAND "${CMAKE_COMMAND}" -E remove -f pyplusplus_{base,control,geometric,tools,util}.{cache,log}
    WORKING_DIRECTORY "${PROJECT_BINARY_DIR}")

=== scripts/CMakeLists.txt ===
install(PROGRAMS ompl_benchmark_statistics.py DESTINATION bin)

=== src/CMakeLists.txt ===
add_subdirectory(ompl)
install(DIRECTORY ompl/ DESTINATION "include/ompl${OMPL_INSTALL_SUFFIX}"
    FILES_MATCHING PATTERN "*.h"
    PATTERN ".DS_Store" EXCLUDE
    PATTERN ".svn" EXCLUDE
    PATTERN "sample_contrib" EXCLUDE
    REGEX "/src$" EXCLUDE
    REGEX "/doc$" EXCLUDE
    REGEX "/tests$" EXCLUDE)

if(${Boost_VERSION} LESS 105300)
    install(DIRECTORY external/omplext_odeint/ DESTINATION "include/omplext_odeint${OMPL_INSTALL_SUFFIX}")
endif()

find_program(CURL curl)
if(CURL)
    set(DOWNLOAD_CMD "${CURL} --location-trusted")
else()
    find_program(WGET wget)
    if (WGET)
        set(DOWNLOAD_CMD "${WGET} --no-check-certificate -O -")
    else()
        message(WARNING "Neither curl nor wget is installed. Install either one of those programs for \"make installpyplusplus\" to succeed.")
    endif()
endif()

# Add target to install Py++ and its dependencies pygccxml and gccxml
if (APPLE)
    # need to compile gccxml with llvm-gcc-4.2 instead of clang
    set(CMAKE_GCCXML_ARGS "-DCMAKE_C_COMPILER=llvm-gcc-4.2 -DCMAKE_CXX_COMPILER=llvm-g++-4.2")
endif()
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/external/installPyPlusPlus.sh.in"
    "${CMAKE_CURRENT_SOURCE_DIR}/external/installPyPlusPlus.sh" @ONLY)
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/external/installPyPlusPlus.bat.in"
    "${CMAKE_CURRENT_SOURCE_DIR}/external/installPyPlusPlus.bat" @ONLY)
if(WIN32)
add_custom_target(installpyplusplus
    COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/external/installPyPlusPlus.bat" VERBATIM)
else(WIN32)
add_custom_target(installpyplusplus
    COMMAND "sh" "${CMAKE_CURRENT_SOURCE_DIR}/external/installPyPlusPlus.sh")
endif(WIN32)

=== tests/CMakeLists.txt ===
# configure location of resources
file(TO_NATIVE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/resources" TEST_RESOURCES_DIR)
if(WIN32)
    # Correct directory separator for Windows
    string(REPLACE "\\" "\\\\" TEST_RESOURCES_DIR "${TEST_RESOURCES_DIR}")
endif(WIN32)
configure_file("${TEST_RESOURCES_DIR}/config.h.in" "${TEST_RESOURCES_DIR}/config.h")

# Disable teamcity reporting for tests by default
option(OMPL_TESTS_TEAMCITY "Enable unit test reporting to TeamCity" OFF)
file(TO_NATIVE_PATH "${CMAKE_CURRENT_SOURCE_DIR}" CURRENT_DIR)
configure_file("${CURRENT_DIR}/BoostTestTeamCityReporter.h.in" "${CURRENT_DIR}/BoostTestTeamCityReporter.h")

# Test datastructures implementation
add_ompl_test(test_heap datastructures/heap.cpp)
add_ompl_test(test_grid datastructures/grid.cpp)
add_ompl_test(test_gridb datastructures/gridb.cpp)
add_ompl_test(test_nearestneighbors datastructures/nearestneighbors.cpp)
add_ompl_test(test_pdf datastructures/pdf.cpp)

# Test utilities
add_ompl_test(test_random util/random/random.cpp)
add_ompl_test(test_machine_specs benchmark/machine_specs.cpp)

# Test base code
add_ompl_test(test_state_operations base/state_operations.cpp)
add_ompl_test(test_state_spaces base/state_spaces.cpp)
add_ompl_test(test_state_storage base/state_storage.cpp)
add_ompl_test(test_ptc base/ptc.cpp)
# Only build the PlannerData test on Boost >= 1.44
if(NOT "${Boost_VERSION}" LESS 104400)
    add_ompl_test(test_planner_data base/planner_data.cpp)
endif(NOT "${Boost_VERSION}" LESS 104400)

# Test kinematic motion planners in 2D environments
add_ompl_test(test_2denvs_geometric geometric/2d/2denvs.cpp)
add_ompl_test(test_2dmap_geometric_simple geometric/2d/2dmap_simple.cpp)
add_ompl_test(test_2dmap_ik geometric/2d/2dmap_ik.cpp)
add_ompl_test(test_2dcircles_opt_geometric geometric/2d/2dcircles_optimize.cpp)

# Test planning with controls on a 2D map
add_ompl_test(test_2dmap_control control/2dmap/2dmap.cpp)
# Only build the PlannerData test on Boost >= 1.44
if(NOT "${Boost_VERSION}" LESS 104400)
    add_ompl_test(test_planner_data_control control/planner_data.cpp)
endif(NOT "${Boost_VERSION}" LESS 104400)

# Python unit tests
if(PYTHON_FOUND AND OMPL_BUILD_PYTESTS AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../py-bindings/bindings")
    add_ompl_python_test(util/test_util.py)
    add_ompl_python_test(base/test_base.py)
    add_ompl_python_test(geometric/test_geometric.py)
    add_ompl_python_test(geometric/test_geometric_compoundstate.py)
    add_ompl_python_test(control/test_control.py)

    # test the python function to boost::function conversion utility functions
    include_directories(${PYTHON_INCLUDE_DIRS})
    add_library(py_boost_function MODULE util/test_py_boost_function.cpp)
    target_link_libraries(py_boost_function ompl ${Boost_PYTHON_LIBRARY} ${PYTHON_LIBRARIES})
    if(WIN32)
        set_target_properties(py_boost_function PROPERTIES OUTPUT_NAME py_boost_function SUFFIX .pyd)
    endif(WIN32)
    get_target_property(PYBOOSTFUNCTION_NAME py_boost_function LOCATION)
    add_custom_command(TARGET py_boost_function POST_BUILD
        COMMAND "${CMAKE_COMMAND}" -E copy "${PYBOOSTFUNCTION_NAME}"
        "${CMAKE_CURRENT_SOURCE_DIR}/util"
        WORKING_DIRECTORY "${LIBRARY_OUTPUT_PATH}")
    add_ompl_python_test(util/test_py_boost_function.py)
endif()

=== src/ompl/CMakeLists.txt ===
#############################################
# Construct configuration file              #
#############################################

file(TO_NATIVE_PATH "${CMAKE_CURRENT_SOURCE_DIR}" VERSION_DIR)
configure_file("${VERSION_DIR}/config.h.in" "${VERSION_DIR}/config.h")


#############################################
# recursively find all *.cpp files that     #
# correspond to the basic ompl library      #
#############################################
file(GLOB_RECURSE OMPL_SOURCE_CODE datastructures/*.cpp util/*.cpp base/*.cpp geometric/*.cpp control/*.cpp tools/*.cpp)



#############################################
# Add enabled extensions to the source code #
#############################################

## replace XXX by the extension
#if (OMPL_EXTENSION_XXX)
#    file(GLOB_RECURSE OMPL_XXX_EXTENSION_SOURCE_CODE extensions/XXX/*.cpp)
#    set(OMPL_SOURCE_CODE ${OMPL_SOURCE_CODE} ${OMPL_XXX_EXTENSION_SOURCE_CODE})
#
##    if additional libraries need to be linked, they are added to manifest.xml for ROS
##    or they are added to the list of OMPL_LINK_LIBRARIES
#
#endif()

if (OMPL_EXTENSION_OPENDE)
    file(GLOB_RECURSE OMPL_OPENDE_EXTENSION_SOURCE_CODE extensions/opende/*.cpp)
    set(OMPL_SOURCE_CODE ${OMPL_SOURCE_CODE} ${OMPL_OPENDE_EXTENSION_SOURCE_CODE})
    list(APPEND OMPL_LINK_LIBRARIES "${OPENDE_LIBRARY}")
endif()

if (OMPL_EXTENSION_TRIANGLE)
  file(GLOB_RECURSE OMPL_TRIANGLE_EXTENSION_SOURCE_CODE extensions/triangle/*.cpp)
  set(OMPL_SOURCE_CODE ${OMPL_SOURCE_CODE} ${OMPL_TRIANGLE_EXTENSION_SOURCE_CODE})
  list(APPEND OMPL_LINK_LIBRARIES ${TRIANGLE_LIBRARY})
endif()

#############################################
# Build and install the library             #
#############################################
if(MSVC OR IS_ICPC)
  add_library(ompl STATIC ${OMPL_SOURCE_CODE})
else(MSVC OR IS_ICPC)
  add_library(ompl SHARED ${OMPL_SOURCE_CODE})
endif(MSVC OR IS_ICPC)
target_link_libraries(ompl
  ${OMPL_LINK_LIBRARIES}
  ${Boost_DATE_TIME_LIBRARY}
  ${Boost_THREAD_LIBRARY}
  ${Boost_SERIALIZATION_LIBRARY}
  ${Boost_FILESYSTEM_LIBRARY}
  ${Boost_SYSTEM_LIBRARY}
  ${Boost_CHRONO_LIBRARY}
  ${CMAKE_THREAD_LIBS_INIT})

if(MSVC)
  set_target_properties(ompl PROPERTIES VERSION "${OMPL_VERSION}" STATIC_LIBRARY_FLAGS "psapi.lib ws2_32.lib")
else(MSVC)
  if (MINGW)
    target_link_libraries(ompl psapi ws2_32)
    set_target_properties(ompl PROPERTIES LINK_FLAGS "-Wl,--export-all-symbols")
  endif(MINGW)
  set_target_properties(ompl PROPERTIES VERSION "${OMPL_VERSION}" SOVERSION "${OMPL_ABI_VERSION}")
endif(MSVC)

# install the library
install(TARGETS ompl DESTINATION lib/)
if(NOT MSVC)
    get_target_property(OMPL_LIBRARY_LOC ompl LOCATION)
    add_custom_command(TARGET ompl POST_BUILD
        COMMAND "${CMAKE_COMMAND}" -E copy "${OMPL_LIBRARY_LOC}"
        "${CMAKE_CURRENT_SOURCE_DIR}/../../py-bindings/ompl/util/libompl${CMAKE_SHARED_LIBRARY_SUFFIX}"
        WORKING_DIRECTORY "${LIBRARY_OUTPUT_PATH}")
endif(NOT MSVC)

=== debian/changelog ===
ompl (0.13.0+git20130920.01d0ca4-1) unstable; urgency=low

  * Add a missing line in the clean part of the rules file.
  * Change compat to 9.
  * Change Standards to 3.9.4.
  * Added dpkg depends to avoid lintian message.
  * Modified description field in control.
  * Deleted Pre-Depends. Not needed, old lintian version.
  * First version in debian (Closes: #706133).
  * Reformat changelog entries.
  * Unblock #72464.

  Previous work:
  (-c3 03 Oct 2013 09:26:57 +0200)
  * Added python-matplotlib as dependency of ompl-demos.

  (-b2 26 Sep 2013 13:23:04 +0200)
  * Removing the python binding. 

  (-a1 21 Sep 2013 15:12:02 +0200) 
  * New upstream version.
  * Using the ompl source instead the omplapp complete suite. First
    packaging.

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Mon, 04 Nov 2013 09:33:48 +0100

ompl (0.12.2-Source-1) UNRELEASED; urgency=low

  * Initial release.  

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Mon, 08 Apr 2013 17:34:13 +0200

=== debian/control ===
Source: ompl
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Leopold Palomo-Avellaneda <leo@alaxarxa.net>
Section: libs
Priority: optional
Build-Depends: debhelper (>= 9),
               cmake,
               curl,
               libboost-date-time-dev (>= 1.50.0),
               libboost-thread-dev (>= 1.50.0),
               libboost-serialization-dev (>= 1.50.0),
               libboost-filesystem-dev (>= 1.50.0),
               libboost-system-dev (>= 1.50.0),
               libboost-program-options-dev (>= 1.50.0),
               libboost-test-dev (>= 1.50.0),
               libflann-dev (>= 1.8.3)
Standards-Version: 3.9.4
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/ompl.git
Vcs-Git: git://anonscm.debian.org/debian-science/packages/ompl.git
Homepage: http://ompl.kavrakilab.org

Package: libompl-dev
Architecture: any
Section: libdevel
Depends: libompl7 (= ${binary:Version}),
         pkg-config,
         ${shlibs:Depends},
         ${misc:Depends},
         libboost-dev
Description: OMPL library development files
 Consists of a set of sampling-based motion planning 
 algorithms. The content of the library is limited to these algorithms,
 which means there is no environment specification, no collision 
 detection or visualization. The library is designed so it can be easily 
 integrated into systems that provide the additional needed components. This
 package contains the needed developtment files to use the library.

Package: libompl7
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Sampling-based motion planning library 
 Consists of a set of sampling-based motion planning 
 algorithms. The content of the library is limited to these algorithms,
 which means there is no environment specification, no collision 
 detection or visualization. The library is designed so it can be easily 
 integrated into systems that provide the additional needed components. This
 package contains the library itself.

Package: ompl-demos
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         python,
         python-matplotlib,
         libompl-dev
Description: OMPL library demos
 Consists of a set of sampling-based motion planning 
 algorithms. The content of the library is limited to these algorithms,
 which means there is no environment specification, no collision 
 detection or visualization. The library is designed so it can be easily 
 integrated into systems that provide the additional needed components. This
 package contains a set of demos of the library.

=== debian/rules ===
#!/usr/bin/make -f

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)  
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_BUILD_OPTIONS += nocheck

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
endif

# These don't need to be exported and if they are we'll get the flags
# duplicated in the command line.
unexport CFLAGS  
unexport CXXFLAGS
unexport LDFLAGS

CMAKE_FLAGS = \
        -DCMAKE_INSTALL_PREFIX=/usr \
        -DCMAKE_VERBOSE_MAKEFILE=ON \
        -DCMAKE_C_FLAGS_RELEASE="$(CFLAGS)" \
        -DCMAKE_CXX_FLAGS_RELEASE="$(CXXFLAGS)" \
        -DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
        -DCMAKE_BUILD_TYPE=Release      \
	-DCMAKE_SKIP_INSTALL_RPATH=TRUE \
	-DOMPL_ODESOLVER=OFF \
        -DOMPL_REGISTRATION=OFF \
	-DOMPL_BUILD_PYBINDINGS=ON \
	-DOMPL_BUILD_PYTESTS=OFF

%:
	dh $@ --builddirectory=build --buildsystem=cmake --parallel

override_dh_clean:
	rm -rf build
	rm -rf CMakeModules/ompl.pc
	rm -rf py-bindings/ompl/bindings_generator.py*
	rm -rf py-bindings/ompl/__init__.pyc
	rm -rf .registered
	rm -rf src/external/installPyPlusPlus.bat
	rm -rf src/external/installPyPlusPlus.sh
	rm -rf src/ompl/config.h
	rm -rf tests/resources/config.h
	rm -rf doc/markdown/api_overview.md  doc/markdown/download.md
	rm -rf doc/markdown/mainpage.md
	rm -rf py-bindings/bindings
	rm -rf tests/BoostTestTeamCityReporter.h
	find py-bindings/ -name *.pypp.*  | xargs -n1 rm -rf
	find py-bindings/ -name *.pyc  | xargs -n1 rm -rf
	find py-bindings/ -name *.so  | xargs -n1 rm -rf 
	dh_clean


override_dh_auto_configure:
	mkdir -p build 
	dh_auto_configure --builddirectory=build -- $(CMAKE_FLAGS) $(CMAKE_ARCH_FLAGS) 

override_dh_auto_build:
# Uncomment this part to prepare the python bindings
#	cd build && $(MAKE) update_bindings
	cd build && $(MAKE) 

override_dh_auto_install:
	dh_auto_install --builddirectory=build

override_dh_install:
	mv debian/tmp/usr/bin/ompl_benchmark_statistics.py debian/tmp/usr/bin/ompl_benchmark_statistics
	dh_install --list-missing

override_dh_auto_test:
	echo "Supressing upstream tests"

=== debian/watch ===
# Watch control file for uscan
# Compulsory line, this is a version 3 file
version=3

https://bitbucket.org/ompl/ompl/downloads/ompl-(.*)\.tar.gz

## ompl 0.14.2%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -13,8 +13,9 @@
                libboost-system-dev (>= 1.50.0),
                libboost-program-options-dev (>= 1.50.0),
                libboost-test-dev (>= 1.50.0),
+	       libode-dev,
                libflann-dev (>= 1.8.3)
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/ompl.git
 Vcs-Git: git://anonscm.debian.org/debian-science/packages/ompl.git
 Homepage: http://ompl.kavrakilab.org
@@ -22,11 +23,12 @@
 Package: libompl-dev
 Architecture: any
 Section: libdevel
-Depends: libompl7 (= ${binary:Version}),
+Depends: libompl9 (= ${binary:Version}),
          pkg-config,
          ${shlibs:Depends},
          ${misc:Depends},
-         libboost-dev
+	 libboost-dev
+Suggests: libode-dev
 Description: OMPL library development files
  Consists of a set of sampling-based motion planning 
  algorithms. The content of the library is limited to these algorithms,
@@ -35,7 +37,7 @@
  integrated into systems that provide the additional needed components. This
  package contains the needed developtment files to use the library.
 
-Package: libompl7
+Package: libompl9
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends}
@@ -62,3 +64,18 @@
  integrated into systems that provide the additional needed components. This
  package contains a set of demos of the library.
 
+Package: libompl9-dbg
+Architecture: any
+Section: debug
+Priority: extra
+Depends: ${shlibs:Depends},
+         ${misc:Depends},
+	 libompl9 (= ${binary:Version}),
+	 libompl-dev
+Description: Sampling-based motion planning library debug symbols
+ Consists of a set of sampling-based motion planning 
+ algorithms. The content of the library is limited to these algorithms,
+ which means there is no environment specification, no collision 
+ detection or visualization. The library is designed so it can be easily 
+ integrated into systems that provide the additional needed components. This
+ package contains the debug symbols of the library.

=== debian/rules ===
--- 
+++ 
@@ -15,9 +15,9 @@
 
 # These don't need to be exported and if they are we'll get the flags
 # duplicated in the command line.
-unexport CFLAGS  
-unexport CXXFLAGS
-unexport LDFLAGS
+#unexport CFLAGS  
+#unexport CXXFLAGS
+#unexport LDFLAGS
 
 CMAKE_FLAGS = \
         -DCMAKE_INSTALL_PREFIX=/usr \
@@ -25,9 +25,9 @@
         -DCMAKE_C_FLAGS_RELEASE="$(CFLAGS)" \
         -DCMAKE_CXX_FLAGS_RELEASE="$(CXXFLAGS)" \
         -DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
-        -DCMAKE_BUILD_TYPE=Release      \
+        -DCMAKE_BUILD_TYPE=RelWithDebInfo \
 	-DCMAKE_SKIP_INSTALL_RPATH=TRUE \
-	-DOMPL_ODESOLVER=OFF \
+	-DOMPL_ODESOLVER=ON \
         -DOMPL_REGISTRATION=OFF \
 	-DOMPL_BUILD_PYBINDINGS=ON \
 	-DOMPL_BUILD_PYTESTS=OFF
@@ -69,9 +69,15 @@
 
 override_dh_install:
 	mv debian/tmp/usr/bin/ompl_benchmark_statistics.py debian/tmp/usr/bin/ompl_benchmark_statistics
+	mkdir -p debian/tmp/usr/share/doc/libompl9-dbg && cp debian/README.Debug debian/tmp/usr/share/doc/libompl9-dbg/
+
 	dh_install --list-missing
 
 override_dh_auto_test:
 	echo "Supressing upstream tests"
 
+override_dh_strip:
+	dh_strip --dbg-package=libompl9-dbg
 
+
+

## ompl 0.14.2%2bdfsg

=== doc/CMakeLists.txt ===
find_package(Doxygen QUIET)

if(DOXYGEN AND NOT OMPLAPP_VERSION)
    if(UNIX)
        execute_process(COMMAND date "+%b %d, %Y"
            OUTPUT_VARIABLE OMPL_RELEASE_DATE
            OUTPUT_STRIP_TRAILING_WHITESPACE)
    endif()
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/markdown/download.md.in"
        "${CMAKE_CURRENT_SOURCE_DIR}/markdown/download.md")
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/markdown/mainpage.md.in"
        "${CMAKE_CURRENT_SOURCE_DIR}/markdown/mainpage.md")
    file(READ "${CMAKE_CURRENT_SOURCE_DIR}/images/ompl.svg" OMPLSVG)
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/markdown/api_overview.md.in"
        "${CMAKE_CURRENT_SOURCE_DIR}/markdown/api_overview.md")

    # add "doc" target if Doxygen is detected
    add_custom_target(doc
        COMMAND ./mkdocs.sh
        WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")

    # add "website" target
    add_custom_target(website
        COMMAND ./mkwebdocs.sh
        DEPENDS doc
        WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")
endif(DOXYGEN AND NOT OMPLAPP_VERSION)

install(FILES man/ompl_benchmark_statistics.1
    DESTINATION share/man/man1 COMPONENT ompl)

## ompl 0.14.2+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,12 +6,9 @@
     # By default, use Release mode
     set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Type of build" FORCE)
 
-    # On 32bit architectures with gcc < 4.7, use RelWithDebInfo
+    # On 32bit architectures, use RelWithDebInfo
     if (CMAKE_COMPILER_IS_GNUCC AND CMAKE_SIZEOF_VOID_P EQUAL 4)
-        execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion OUTPUT_VARIABLE GCC_VERSION)
-        if (GCC_VERSION VERSION_LESS 4.7)
-            set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Type of build" FORCE)
-        endif()
+        set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Type of build" FORCE)
     endif()
 endif()
 
@@ -57,6 +54,13 @@
 # have the try_join_for call
 find_package(Boost QUIET 1.50)
 
+# If Boost is not found at all, the check for version 1.50 below will die in
+# the most ungraceful manner because Boost_VERSION is not defined.  Define the
+# variable here for a more useful error.
+if (NOT ${Boost_FOUND})
+    set(Boost_VERSION 0)
+endif()
+
 # try_join_for requires the chrono library, so if we will use
 # try_join_for, we need to include the chrono component
 # Must recheck the Boost version, since update_bindings will re-run CMake
@@ -81,12 +85,34 @@
   option(OMPL_ODESOLVER "Enable OMPL ODE solver classes" OFF)
 endif()
 
+# on OS X we need to check whether to use libc++ or libstdc++ with clang++
+if(APPLE AND CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
+    include(GetPrerequisites)
+    get_prerequisites("${Boost_SYSTEM_LIBRARY}" _libs 0 0 "/" "")
+    set(CXXSTDLIB "")
+    foreach(_lib ${_libs})
+        if(_lib MATCHES "libc\\+\\+")
+            set(CXXSTDLIB "libc++")
+        elseif(_lib MATCHES "libstdc\\+\\+")
+            set(CXXSTDLIB "libstdc++")
+        endif()
+    endforeach()
+    if(CXXSTDLIB)
+        add_definitions(-stdlib=${CXXSTDLIB})
+    endif()
+endif()
+
+
 # pthread is sometimes needed, depending on OS / compiler
 find_package(Threads QUIET)
 
 enable_testing()
 
-# ODE is only needed for Open Dynamics Engine bindings
+# MORSE is only needed for Modular OpenRobots Simulation Engine bindings
+find_package(MORSE QUIET)
+set(OMPL_EXTENSION_MORSE ${MORSE_FOUND})
+
+# OpenDE is only needed for Open Dynamics Engine bindings
 find_package(OpenDE QUIET)
 set(OMPL_EXTENSION_OPENDE ${OPENDE_FOUND})
 if (OPENDE_FOUND)
@@ -105,6 +131,15 @@
 if (FLANN_FOUND)
     set(OMPL_HAVE_FLANN 1)
     include_directories(SYSTEM "${FLANN_INCLUDE_DIRS}")
+endif()
+
+option(OMPL_LOCAL_PYPLUSPLUS_INSTALL "Whether Py++ and dependencies should be installed in the build directory" OFF)
+set(SUDO "sudo")
+set(CMAKE_GCCXML_ARGS "")
+if(OMPL_LOCAL_PYPLUSPLUS_INSTALL)
+    set(SUDO "")
+    set(CMAKE_GCCXML_ARGS "-DCMAKE_INSTALL_PREFIX=${PROJECT_BINARY_DIR}/pyplusplus")
+    set(DISTUTILS_ARGS "--prefix=${PROJECT_BINARY_DIR}/pyplusplus")
 endif()
 
 add_subdirectory(py-bindings)
@@ -120,11 +155,14 @@
   set(PKG_OMPL_LIBS "-lompl")
   set(pkg_conf_file "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/ompl.pc")
   configure_file("${pkg_conf_file}.in" "${pkg_conf_file}" @ONLY)
-  install(FILES "${pkg_conf_file}" DESTINATION lib/pkgconfig/
-    COMPONENT pkgconfig RENAME "ompl${OMPL_INSTALL_SUFFIX}.pc")
+  install(FILES "${pkg_conf_file}"
+    DESTINATION lib/pkgconfig/
+    COMPONENT ompl
+    RENAME "ompl${OMPL_INSTALL_SUFFIX}.pc")
 
   install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/doc/markdown/FindOMPL.cmake"
     DESTINATION "share/ompl${OMPL_INSTALL_SUFFIX}"
+    COMPONENT ompl
     RENAME ompl-config.cmake)
   if (NOT ${CMAKE_VERSION} VERSION_LESS 2.8.6)
     include(WriteBasicConfigVersionFile)
@@ -132,7 +170,8 @@
       "${CMAKE_CURRENT_BINARY_DIR}/ompl-config-version.cmake"
       VERSION ${OMPL_VERSION} COMPATIBILITY SameMajorVersion)
     install(FILES "${CMAKE_CURRENT_BINARY_DIR}/ompl-config-version.cmake"
-      DESTINATION "share/ompl${OMPL_INSTALL_SUFFIX}")
+      DESTINATION "share/ompl${OMPL_INSTALL_SUFFIX}"
+      COMPONENT ompl)
   endif()
 endif()

=== demos/CMakeLists.txt ===
--- 
+++ 
@@ -23,11 +23,15 @@
 
   add_ompl_demo(demo_StateSampling StateSampling.cpp)
   add_ompl_demo(demo_GeometricCarPlanning GeometricCarPlanning.cpp)
+  add_ompl_demo(demo_Point2DPlanning Point2DPlanning.cpp)
   add_ompl_demo(demo_HybridSystemPlanning HybridSystemPlanning.cpp)
+  add_ompl_demo(demo_KinematicChainBenchmark KinematicChainBenchmark.cpp)
+  add_ompl_demo(demo_HypercubeBenchmark HypercubeBenchmark.cpp)
   aux_source_directory(Koules Koules_SRC)
   add_ompl_demo(demo_Koules ${Koules_SRC})
 
   add_ompl_demo(demo_OptimalPlanning OptimalPlanning.cpp)
+  add_ompl_demo(demo_PlannerProgressProperties PlannerProgressProperties.cpp)
 
   if (OMPL_EXTENSION_OPENDE)
     add_ompl_demo(demo_OpenDERigidBodyPlanning OpenDERigidBodyPlanning.cpp)
@@ -41,9 +45,14 @@
   if(NOT "${Boost_VERSION}" LESS 104400)
     add_ompl_demo(demo_PlannerData PlannerData.cpp)
   endif(NOT "${Boost_VERSION}" LESS 104400)
+
 endif(OMPL_BUILD_DEMOS)
 
 file(GLOB OMPL_DEMO_CXX_FILES "*.cpp")
 file(GLOB OMPL_DEMO_PY_FILES "*.py")
-install(FILES ${OMPL_DEMO_CXX_FILES} ${OMPL_DEMO_PY_FILES} DESTINATION "${OMPL_DEMO_INSTALL_DIR}")
-install(DIRECTORY Koules DESTINATION "${OMPL_DEMO_INSTALL_DIR}")
+install(FILES ${OMPL_DEMO_CXX_FILES} ${OMPL_DEMO_PY_FILES}
+    DESTINATION "${OMPL_DEMO_INSTALL_DIR}"
+    COMPONENT ompl)
+install(DIRECTORY Koules
+    DESTINATION "${OMPL_DEMO_INSTALL_DIR}"
+    COMPONENT ompl)

=== debian/changelog ===
ompl (0.14.2+dfsg-1) unstable; urgency=low

  * New upstream version. Repacked dfsg
  * Added licenses to copyright (Closes: #741603).
  * Added README.Debug to debug package.
  * Deleted patches, not needed.
  * Added libode-dev to compile extensions. And suggested 
    in the Suggests field.

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Mon, 26 May 2014 10:02:58 +0200

ompl (0.14.1-1) unstable; urgency=low

  * Added debug version of the library.
  * New upstream version.
  * Bump to soname 9.
  * Upgraded to standards 3.9.5.

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Mon, 13 Jan 2014 10:15:46 +0100

=== debian/watch ===
# Watch control file for uscan
# Compulsory line, this is a version 3 file
version=3
opts=dversionmangle=s/\.dfsg// \
https://bitbucket.org/ompl/ompl/downloads/ompl-(.*)\.tar.gz

## ompl 1.0.0%2Bds2

=== py-bindings/CMakeLists.txt ===
--- 
+++ 
@@ -13,6 +13,9 @@
     endif(WIN32)
 
     set(OMPL_MODULES base control geometric tools util)
+    if(OMPL_EXTENSION_MORSE)
+        list(APPEND OMPL_MODULES morse)
+    endif()
 
     if(PY_OMPL_GENERATE)
         # need to run cmake to regenerate ompl/bindings_generator.py if
@@ -29,7 +32,10 @@
         add_dependencies(update_control_bindings update_geometric_bindings)
         add_dependencies(update_control_bindings update_base_bindings)
         add_dependencies(update_tools_bindings update_control_bindings)
-
+        if(OMPL_EXTENSION_MORSE)
+            add_dependencies(update_morse_bindings update_base_bindings)
+            add_dependencies(update_morse_bindings update_control_bindings)
+        endif()
     endif(PY_OMPL_GENERATE)
 
     if(PY_OMPL_COMPILE AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/bindings")
@@ -38,7 +44,36 @@
         endforeach(module)
 
         install(DIRECTORY ompl DESTINATION "${OMPL_PYTHON_INSTALL_DIR}"
-            PATTERN .svn EXCLUDE PATTERN "*.pyc" EXCLUDE PATTERN "_*.so" EXCLUDE)
+            COMPONENT python
+            PATTERN "*.pyc" EXCLUDE
+            PATTERN "__pycache__" EXCLUDE
+            PATTERN "_*.so" EXCLUDE
+            PATTERN "app" EXCLUDE
+            PATTERN "morse" EXCLUDE)
+        # put app submodule in omplapp component
+        if(OMPLAPP_VERSION)
+            install(DIRECTORY ompl/app
+                DESTINATION "${OMPL_PYTHON_INSTALL_DIR}/ompl"
+                COMPONENT omplapp
+                PATTERN "*.pyc" EXCLUDE
+                PATTERN "__pycache__" EXCLUDE
+                PATTERN "_*.so" EXCLUDE)
+        endif()
+        # put morse submodule in morse component
+        if(OMPL_EXTENSION_MORSE)
+            install(DIRECTORY ompl/morse
+                DESTINATION "${OMPL_PYTHON_INSTALL_DIR}/ompl"
+                COMPONENT morse
+                PATTERN "*.pyc" EXCLUDE
+                PATTERN "__pycache__" EXCLUDE
+                PATTERN "_*.so" EXCLUDE
+                PATTERN "addons" EXCLUDE)
+            # blender add-on
+            install(DIRECTORY ompl/morse/addons
+                DESTINATION "share/ompl${OMPL_INSTALL_SUFFIX}"
+                COMPONENT morse
+                PATTERN "*.pyc" EXCLUDE)
+        endif()
     endif()
 
 endif(OMPL_BUILD_PYBINDINGS)

=== scripts/CMakeLists.txt ===
install(PROGRAMS ompl_benchmark_statistics.py
    DESTINATION ${CMAKE_INSTALL_BINDIR}
    COMPONENT ompl
    RENAME ompl_benchmark_statistics${OMPL_INSTALL_SUFFIX}.py)

=== src/CMakeLists.txt ===
add_subdirectory(ompl)
install(DIRECTORY ompl/ DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/ompl${OMPL_INSTALL_SUFFIX}"
    COMPONENT ompl
    FILES_MATCHING PATTERN "*.h"
    PATTERN ".DS_Store" EXCLUDE
    PATTERN "sample_contrib" EXCLUDE
    REGEX "/src$" EXCLUDE
    REGEX "/doc$" EXCLUDE
    REGEX "/tests$" EXCLUDE)

if(${Boost_VERSION} LESS 105300)
    install(DIRECTORY external/omplext_odeint/
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/omplext_odeint${OMPL_INSTALL_SUFFIX}"
        COMPONENT ompl)
endif()

find_program(CURL curl)
if(CURL)
    set(DOWNLOAD_CMD "${CURL} --location-trusted")
else()
    find_program(WGET wget)
    if (WGET)
        set(DOWNLOAD_CMD "${WGET} --no-check-certificate -O -")
    else()
        message(WARNING "Neither curl nor wget is installed. Install either one of those programs for \"make installpyplusplus\" to succeed.")
    endif()
endif()

# Add target to install Py++ and its dependencies pygccxml and gccxml
if (APPLE)
    # need to compile gccxml with llvm-gcc-4.2 instead of clang
    set(CMAKE_GCCXML_ARGS "${CMAKE_GCCXML_ARGS} -DCMAKE_C_COMPILER=llvm-gcc-4.2 -DCMAKE_CXX_COMPILER=llvm-g++-4.2")
endif()
if(WIN32)
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/external/installPyPlusPlus.bat.in"
        "${CMAKE_CURRENT_SOURCE_DIR}/external/installPyPlusPlus.bat" @ONLY)
    add_custom_target(installpyplusplus
        COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/external/installPyPlusPlus.bat" VERBATIM)
else(WIN32)
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/external/installPyPlusPlus.sh.in"
        "${CMAKE_CURRENT_SOURCE_DIR}/external/installPyPlusPlus.sh" @ONLY)
    add_custom_target(installpyplusplus
        COMMAND "sh" "${CMAKE_CURRENT_SOURCE_DIR}/external/installPyPlusPlus.sh")
endif(WIN32)
